:- include( 'processes' ).
:- include( 'muc' ).

processdef( lamp, [nolight] * ( [on=false, lamp] + [on=true, lampon] ) ).
processdef( lampon, [light] * ( [on=true, lampon] + [on=false, lamp] ) ).

processdef( car, [send(wait), car_wait(5)] ).
processdef( car_wait(N), [go=true,car_go] + [tick,car_wait(N1)], N1 is N-1).
processdef( car_wait(0), car ).

processdef( car_go, [send(enter),tick, send(enter),
tick(4),send(exit), tick, send(exit), car ] ).

processdef( lightctr, [llight:=false,rlight:=false,
    [update(lwait),lgreen]+ [update(rwait),rgreen] ] ).
processdef( lgreen, [llight:=true,tick(6),lightleft] ).
processdef( rgreen, [rlight:=true,tick(6),lightright] ).
processdef( lightleft, [send(getempty),
    [empty=true,llight:=false,lightctr]+[empty=false,lightleft]] ).
processdef( lightright, [send(getempty),
    [empty=true,rlight:=false,lightctr]+[empty=false,lightright]] ).

processdef( bridge, bridge(0) ).
processdef( bridgel(0), bridge(0) ).
processdef( bridger(0), bridge(0) ).

processdef( bridge(0), 
    [update(lin),bridgel(1)] + [update(rin),bridger(1)] + 
    [update(request),empty:=true,bridge(0)] ).

processdef( bridgel(N), [fromleft] * (
    [update(lin),bridgel(NP)] + [update(lout),bridgel(NM)] + 
    [update(request), [fromleft] * [empty:=false,bridgel(N)]] ),
    (NP is N + 1, NM is N - 1) ).

processdef( bridger(N), [fromright] * (
     [update(rin),bridger(NP)] + [update(rout),bridger(NM)] + 
    [update(request), [fromright] * [empty:=false,bridger(N)]] ),
    (NP is N + 1, NM is N - 1) ).

net( oneway, 
    [lcar:car,rcar:car,b:bridge,c:lightctr,llight:lamp,rlight:lamp],
    [lcar^enter/b^lin, lcar^leave/b^lout, lcar^wait/c^lwait, 
     rcar^enter/b^rin, rcar^leave/b^rout, rcar^wait/c^rwait, 
     b^empty/c^empty, c^getempty/b^request,
     c^llight/llight^on, c^llight/lcar^go, 
     c^rlight/rlight^on, c^rlight/rcar^go], [] ).

crash(R) :-
    failure( ag( ifthen(fromleft,all([send(rcar^enter)],false)) /\
                 ifthen(fromright,all([send(lcar^enter)], false)) ),
	    oneway, R).

deadlock(R) :-
    failure( ag( ef( allbut([tick], true) ) ), oneway, R ).

liveness(R) :-
    failure( ag( all([send(lcar^wait)], h([send(lcar^enter)]) ) ),
             oneway, R ).
